100 CLS
110 FONT 2
120 LOCATE 20,0
130 PRINT "DUINOMITE - CANVIEW FOR PRIUS GEN2"
140 PRINT " "
150 LOCATE 20,20
160 PRINT "CANPORT OPEN"
170 REM declare variables for message reception
180 DIM rxId : DIM rxType : DIM rxLen : DIM rxData(8) : DIM rxOk
190 REM set CAN baudrate to 500 kbps and connect to the CAN bus
200 CANOPEN 500000
210 REM start the program loop
220 DO
230 REM quit program when user pressed 'q'
240 IF INKEY$ = "q" THEN EXIT
250 REM check if a message was received
260 CANRCV rxId, rxType, rxLen, rxData(0), rxOk
270 IF rxOk = 1 THEN
280 REM process message data
290 id$ = HEX$(rxId)+SPACE$(1)
300 REM IF rxType = 0 THEN type$ = "STD" ELSE type$ = "EXT"
310 len$ = STR$(rxLen)+SPACE$(1)
320 d0$ = HEX$(rxData(0))+SPACE$(1)
330 d1$ = HEX$(rxData(1))+SPACE$(1)
340 d2$ = HEX$(rxData(2))+SPACE$(1)
350 d3$ = HEX$(rxData(3))+SPACE$(1)
360 d4$ = HEX$(rxData(4))+SPACE$(1)
370 d5$ = HEX$(rxData(5))+SPACE$(1)
380 d6$ = HEX$(rxData(6))+SPACE$(1)
390 d7$ = HEX$(rxData(7))+SPACE$(1)
400 REM d1$ = HEX$(02)+SPACE$(1)
410 REM display the message X348 AND X3C8
420 FONT 2
430 LOCATE 20,40 
440 PRINT "ID LE B0 B1 B2 B3 B4 B5 B6 B7"
450 IF HEX$(rxId) = "348" THEN GOTO 470
460 GOTO 490
470 LOCATE 20,60 
480 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
490 IF HEX$(rxId) = "3C8" THEN GOTO 510
500 GOTO 530
510 LOCATE 20,80 
520 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
530 IF HEX$(rxId) = "38" THEN GOTO 550
540 GOTO 570
550 LOCATE 20,100
560 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
570 IF HEX$(rxId) = "3CA" THEN GOTO 590
580 GOTO 610
590 LOCATE 20,120
600 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
610 IF HEX$(rxId) = "244" THEN GOTO 630
620 GOTO 650
630 LOCATE 20,140
640 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
650 IF HEX$(rxId) = "39" THEN GOTO 670
660 GOTO 690
670 LOCATE 20,160
680 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
690 IF HEX$(rxId) = "3B" THEN GOTO 710
700 GOTO 730
710 LOCATE 20,180
720 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
730 IF HEX$(rxId) = "526" THEN GOTO 750
740 GOTO 780
750 LOCATE 20,200
760 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
770 REM
780 IF HEX$(rxId) = "3A" THEN GOTO 800
790 GOTO 830
800 LOCATE 20,220
810 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
820 REM
830 IF HEX$(rxId) = "3E" THEN GOTO 850
840 GOTO 880
850 LOCATE 20,240
860 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
870 REM
880 IF HEX$(rxId) = "B1" THEN GOTO 900
890 GOTO 930
900 LOCATE 20,260
910 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
920 REM
930 IF HEX$(rxId) = "3CD" THEN GOTO 950
940 GOTO 980
950 LOCATE 20,280
960 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
970 REM
980 IF HEX$(rxId) = "3CF" THEN GOTO 1000
990 GOTO 1030
1000 LOCATE 20,300
1010 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
1020 REM
1030 IF HEX$(rxId) = "484" THEN GOTO 1050
1040 GOTO 1080
1050 LOCATE 20,320
1060 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
1070 REM
1080 IF HEX$(rxId) = "25" THEN GOTO 1100
1090 GOTO 1130
1100 LOCATE 20,340
1110 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
1120 REM
1130 IF HEX$(rxId) = "540" THEN GOTO 1150
1140 GOTO 1180
1150 LOCATE 20,360
1160 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
1170 REM CALL 
1180 IF HEX$(rxId) = "30" THEN GOTO 1200
1190 GOTO 1230
1200 LOCATE 20,380
1210 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
1220 REM
1230 IF HEX$(rxId) = "230" THEN GOTO 1250
1240 GOTO 1280
1250 LOCATE 20,400
1260 PRINT id$;len$;d0$;d1$;d2$;d3$;d4$;d5$;d6$;d7$
1270 REM
1280 REM
1290 ENDIF
1300 LOOP
1310 CANCLOSE
1320 CLS
1330 PRINT "            CANPORT CLOSED"
1340 END
